require "ISUI/ISPanelJoypad"
local SleepingBags = {};
SleepingBags["RedBedroll"]=1;
SleepingBags["GreenBedroll"]=1;
SleepingBags["GreyBedroll"]=1;
SleepingBags["YellowBedroll"]=1;
SleepingBags["PurpleBedroll"]=1;
SleepingBags["BlueBedroll"]=1;
SleepingBags["SleepingbagRolled"]=1;
SleepingBags["SleepingbagBKRolled"]=1;
SleepingBags["SleepingbagGRolled"]=1;
SleepingBags["SleepingbagLBRolled"]=1;
SleepingBags["SleepingbagORolled"]=1;
SleepingBags["SleepingbagPRolled"]=1;
SleepingBags["SleepingbagRRolled"]=1;

function ISHotbar:activateSlot(slotIndex)
	local item = self.attachedItems[slotIndex]
	if not item then return end
	if item:getAttachedSlot() ~= slotIndex then
		error "item:getAttachedSlot() ~= slotIndex"
	end
	
	------ G.E.A.R. CLOTHING EQUIP -----------------\\
	if item:getCategory() == "Clothing" then
		if item:isEquipped() then
			ISTimedActionQueue.add(ISUnequipAction:new(self.chr, item, 50))
		else
			ISTimedActionQueue.add(ISWearClothing:new(self.chr, item, 50))
		end
		return
	end
	-----------------------------------------------//

	------ G.E.A.R. EAT FOOD -----------------------\\
	if item:IsFood() and item:getHungerChange() < 0 then
		if self.chr:getMoodles():getMoodleLevel(MoodleType.FoodEaten) < 3 or self.chr:getNutrition():getCalories() < 1000 then
			ISTimedActionQueue.add(ISEatFoodAction:new(self.chr, item, 0.25));
			return
		end
	end
	------------------------------------------------//
	
	
	---- Torches get equipped, not turned on, first.
	if item:getName() == "Hand Torch" then
		self:equipItem(item)
	end
	
	if item:canBeActivated() then
		item:setActivated(not item:isActivated())
		return
	end
	
	--create a new kit/box when equipped?
	if item:getCategory() == "Container" then
		local playinv = self.chr:getInventory()
		local kitbox = self.chr:getWornItem("Kit");
		if not item:isEquipped() then
			--Replace the the current attached kit with the one that was on our back already.
			local slot = self.availableSlot[item:getAttachedSlot()]
			local slotDef = slot.def
			self.chr:setWornItem(item:canBeEquipped(), item);
			if kitbox then self:attachItem(kitbox, slotDef.attachments[kitbox:getAttachmentType()], item:getAttachedSlot(), self:getSlotDef(slot.slotType), true) end
			return
		end
	elseif SleepingBags[item:getType()] == 1 then
		--unroll sleeping bag and place it
		local itype = item:getType();
		local bag_color = string.sub(itype,1,string.find(itype,"Bedroll")-1) -- get the color from the item type.
		local recipe = getScriptManager():getRecipe("Unroll "..bag_color.." Sleeping Bag")
		if not recipe then
			recipe = getScriptManager():getRecipe("UnRoll Sleeping Bag") -- might be paperwyverns bag.
		end
		if not recipe or not item then return end
		local action = ISCraftAction:new(self.chr, item, recipe:getTimeToMake(), recipe, self.chr:getInventory(), nil)
		action:setOnComplete(function (pplayer,pitem)
			local mo = ISMoveableCursor:new(pplayer);
			getCell():setDrag(mo, mo.player);
			mo:setMoveableMode("place");
			mo:tryInitialItem(pitem);
		end,self.chr,item)
		ISTimedActionQueue.add(action)
		return
	elseif item:getType() == "PackOfSmokes" then
		--For my smokes mod. Smoke One cigarette from pack.
		local recipe = getScriptManager():getRecipe("Smoke One")
		local action = ISCraftAction:new(self.chr, item, recipe:getTimeToMake(), recipe, self.chr:getInventory(), nil)
		ISTimedActionQueue.add(action)
		return
	end
	
	BetterEquip(self.chr,item)
end

function BetterEquip(player,item)
	ISInventoryPaneContextMenu.transferIfNeeded(player, item)
	local equip = true;
	if player:isEquipped(item) then
		ISTimedActionQueue.add(ISUnequipAction:new(player, item, 20));
		equip = false;
	end
	
	if equip then
		local primary = player:getPrimaryHandItem()
		-- Drop corpse or generator
		if isForceDropHeavyItem(primary) then
			ISTimedActionQueue.add(ISUnequipAction:new(player, primary, 50));
		end
		ISTimedActionQueue.add(ISEquipWeaponAction:new(player, item, 20, true, item:isTwoHandWeapon()));
	end
	
	player:getInventory():setDrawDirty(true);
	getPlayerData(player:getPlayerNum()).playerInventory:refreshBackpacks();
--	self:refresh();
end