function Replace_Bag(items, newitem, player)
	local item = nil;
	for i=0,items:size()-1 do
		local splittype = stringSplit(items:get(i):getType(),"_");
		if #splittype > 1 then -- match the second part of the item type.
			if splittype[1] == stringSplit(newitem:getType(),"_")[1] then item = items:get(i); end
		end
	end
	--deal with custom names
	local itemClone = InventoryItemFactory.CreateItem(item:getType())
	if item:getName() ~= itemClone:getName() then
		newitem:setCustomName(true)
		newitem:setName(item:getName())
	end
	
	local playinv = player:getInventory();
	newitem:getItemContainer():setItems(item:getItemContainer():getItems()) -- move the items
	newitem:getVisual():setTextureChoice(item:getVisual():getTextureChoice()) -- set the texture choice
	--replace the pack where it was. this _should_ retain what was already attached.
	if player:getWornItem("Back") == nil then
		--no backpack on, so equip it.
		ISTimedActionQueue.add(ISWearClothing:new(player, newitem, 0))
	elseif player:getPrimaryHandItem() == item then 
		ISTimedActionQueue.add(ISEquipWeaponAction:new(player, newitem, 0, true, false));
	elseif player:getSecondaryHandItem() == item then 
		ISTimedActionQueue.add(ISEquipWeaponAction:new(player, newitem, 0, false, false));
	end
end
function SBAA_BatteryInsert(items,newitem,player)
	local batt = nil
	local light = nil
	for i=0,items:size()-1 do
		local item = items:get(i)
		if item:getType() == "Battery" then batt = item end
		if item:getType() == "EmptyMilitaryFlashlight" or item:getType() == "EmptyMilitaryFlashlight2" then
			light=item
		end
	end
	local newlight = nil
	if light:getType() == "EmptyMilitaryFlashlight" then
		newlight = InventoryItemFactory.CreateItem("Base.MilitaryFlashlight")
	else
		newlight = InventoryItemFactory.CreateItem("Base.MilitaryFlashlight2")
	end
	newlight:setUsedDelta(batt:getUsedDelta())
	player:getInventory():AddItem(newlight)
	player:getInventory():Remove(batt)
end

function SBAA_BatterySwap(items, newitem, player)
	local batt = nil
	for i=0,items:size()-1 do
		local item = items:get(i)
		if item:getType() == "MilitaryFlashlight" or item:getType() == "MilitaryFlashlight2" then light = item end
		if item:getType() == "Battery" then batt = item end
	end
	if light == nil then
		player:getInventory():getFirstTypeRecurse("MilitaryFlashlight")
	end
	if light and light:getUsedDelta() > 0 then
		-- the battery wasnt drained, make one with the remaining.
		local newbatt = InventoryItemFactory.CreateItem("Base.Battery")
		newbatt:setUsedDelta(light:getUsedDelta())
		player:getInventory():AddItem(newbatt)
	end
	--player:getInventory():Remove(newitem) --remove the light made by the recipe script.
	if light then light:setUsedDelta(batt:getUsedDelta()) end
	player:getInventory():Remove(batt)
	player:StopAllActionQueue() -- stop the arbitrary "all" option.
end

function SBAA_BatteryDrain(items,newitem, player)
	local light = nil
	local batt = nil
	for i=0,items:size()-1 do
		local item = items:get(i)
		if item:getType() == "MilitaryFlashlight" or item:getType() == "MilitaryFlashlight2" then light = item end
		if item:getType() == "Battery" then batt = item end
	end
	if light:getUsedDelta() <= 0 then
		player:getInventory():Remove(newitem) --light is drained, no free battery.
	else
		newitem:setUsedDelta(light:getUsedDelta())
	end
	if light:getType() == "MilitaryFlashlight" then
		player:getInventory():AddItem(InventoryItemFactory.CreateItem("Base.EmptyMilitaryFlashlight"))
	else
		player:getInventory():AddItem(InventoryItemFactory.CreateItem("Base.EmptyMilitaryFlashlight2"))
	end
	player:getInventory():Remove(light)
end

function SBAA_CanDrain(item)
	if item:getUsedDelta() <= 0 then
		return false
	end
	return true
end

function stringSplit (inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end